package dev.shadowsoffire.apotheosis.village.compat;

import net.minecraft.world.item.crafting.Recipe;
import net.minecraft.world.inventory.MenuType;
import dev.shadowsoffire.apotheosis.village.fletching.FletchingContainer;
import mezz.jei.api.registration.IRecipeTransferRegistration;
import java.util.List;
import dev.shadowsoffire.apotheosis.village.fletching.FletchingRecipe;
import dev.shadowsoffire.apotheosis.Apoth;
import net.minecraft.client.Minecraft;
import mezz.jei.api.registration.IRecipeRegistration;
import mezz.jei.api.recipe.category.IRecipeCategory;
import mezz.jei.api.registration.IRecipeCategoryRegistration;
import mezz.jei.api.recipe.RecipeType;
import net.minecraft.world.level.ItemLike;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.level.block.Blocks;
import dev.shadowsoffire.apotheosis.Apotheosis;
import mezz.jei.api.registration.IRecipeCatalystRegistration;
import net.minecraft.resources.ResourceLocation;
import mezz.jei.api.JeiPlugin;
import mezz.jei.api.IModPlugin;

@JeiPlugin
public class VillageJEIPlugin implements IModPlugin
{
    public ResourceLocation getPluginUid() {
        return new ResourceLocation("apotheosis", "village_module");
    }
    
    public void registerRecipeCatalysts(final IRecipeCatalystRegistration reg) {
        if (!Apotheosis.enableVillage) {
            return;
        }
        reg.addRecipeCatalyst(new ItemStack((ItemLike)Blocks.f_50622_), new RecipeType[] { FletchingCategory.TYPE });
    }
    
    public void registerCategories(final IRecipeCategoryRegistration reg) {
        if (!Apotheosis.enableVillage) {
            return;
        }
        reg.addRecipeCategories(new IRecipeCategory[] { (IRecipeCategory)new FletchingCategory(reg.getJeiHelpers().getGuiHelper()) });
    }
    
    public void registerRecipes(final IRecipeRegistration reg) {
        if (!Apotheosis.enableVillage) {
            return;
        }
        reg.addRecipes((RecipeType)FletchingCategory.TYPE, (List)Minecraft.m_91087_().f_91073_.m_7465_().m_44051_().stream().filter(r -> r.m_6671_() == Apoth.RecipeTypes.FLETCHING).map(r -> (FletchingRecipe)r).toList());
    }
    
    public void registerRecipeTransferHandlers(final IRecipeTransferRegistration reg) {
        if (!Apotheosis.enableVillage) {
            return;
        }
        reg.addRecipeTransferHandler((Class)FletchingContainer.class, (MenuType)Apoth.Menus.FLETCHING.get(), (RecipeType)FletchingCategory.TYPE, 1, 3, 4, 36);
    }
}
